{***********************************************************************
Unit gfx_ColorCtrl.PAS v1.0
    (c) by Andreas Moser, amoser@amoser.de,

    Delphi version : Delphi 4

    gfx_colorctrl is part of the gfx_library collection

    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.

    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.


    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."

    All brand and product names are marks or registered marks of their
    respective companies.

    Please report bugs to:
    Andreas Moser  amoser@amoser.de

********************************************************************************}
unit gfx_ColorCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,gfx_basedef,gfx_effects,gfx_effectex,gfx_Rotresize,gfx_files, Mask, ExtDlgs,io_files,
  Histogram, ComCtrls, PreviewPanel, Spin, ExtTrackBar;
type
  TColCtrlForm = class(TForm)
    Button2: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button3: TButton;
    PageControl1: TPageControl;
    HSLSheet: TTabSheet;
    ContrastSheet: TTabSheet;
    ProgressBar1: TProgressBar;
    GammaSheet: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ExtTrackBar1: TExtTrackBar;
    ExtTrackBar2: TExtTrackBar;
    ExtTrackBar3: TExtTrackBar;
    RGBSheet: TTabSheet;
    RedTrack: TExtTrackBar;
    GreenTrack: TExtTrackBar;
    BlueTrack: TExtTrackBar;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    BlueSpin: TSpinEdit;
    GreenSpin: TSpinEdit;
    RedSpin: TSpinEdit;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    PreviewPanel1: TPreviewPanel;
    Edit1: TEdit;
    GammaTrack: TExtTrackBar;
    Label19: TLabel;
    Shape1: TShape;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Image1: TImage;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    ExtTrackBar4: TExtTrackBar;
    ExtTrackBar5: TExtTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PreviewPanel1OrgPosChanged(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure ExtTrackBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExtTrackBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExtTrackBar1Change(Sender: TObject);
    procedure RedTrackMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RedTrackMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RedTrackChange(Sender: TObject);
    procedure RedSpinChange(Sender: TObject);
    procedure SwapPlanesClick(Sender: TObject);
    procedure GammaTrackChange(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure ExtTrackBar5Change(Sender: TObject);
    procedure ExtTrackBar5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpinEdit4Change(Sender: TObject);
  private
    SwapMode:TSwapPlanes;
    procedure RGBClick;
    procedure LigCont;
    { Private-Deklarationen }
  public
    ResultBitmap:TBitmap;
    Gamma:Double;
    { Public-Deklarationen }
  end;

var
 ColCtrlForm:TColCtrlForm;
implementation


{$R *.DFM}



procedure TColCtrlForm.FormCreate(Sender: TObject);
var k,i:Integer;
begin
  DecimalSeparator:='.';
  SpinEdit1.Value:=ExttrackBar1.Position;
  SpinEdit2.Value:=ExttrackBar2.Position;
  SpinEdit3.Value:=ExttrackBar3.Position;
  Gamma:=1;

  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.Canvas.MoveTo(0,Image1.Height-1);
  Image1.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
  Image1.Picture.Bitmap.Canvas.FillRect(Image1.ClientRect);
  for i:=1 to 255 do
  begin
    k:=IntGamma(Gamma,i);
    Image1.Picture.Bitmap.Canvas.LineTo(i div 2,Image1.Height-( k div 2)-1);
  end;
  Image1.Repaint;

  Edit1.Text:=FloatToStr(Gamma);
  ResultBitmap:=tBitmap.Create;
end;


procedure TColCtrlForm.Button2Click(Sender: TObject);
var tb:TBitmap;
begin
  Screen.Cursor:=crHourGlass;
  try
    if not PreviewPanel1.SourceBitmap.Empty then
    if PageControl1.ActivePage=HSLSheet then
    begin
      EffectColorize(PreviewPanel1.SourceBitmap,ResultBitmap,
      ExtTrackBar1.Position,ExtTrackBar2.Position,ExtTrackBar3.Position,nil);
      PreviewPanel1.SourceBitmap.Assign(ResultBitmap);
    end
    else if PageControl1.ActivePage=RGBSheet then
    begin
      if SwapMode<>swapnone then begin
        tb:=TBitmap.Create;
        try
          EffectSwapChannels(PreviewPanel1.SourceBitmap,tb,SwapMode,nil);
          EffectIncDecRGB(tb,ResultBitmap,RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
        finally
          tb.Free;
        end;
      end else
      EffectIncDecRGB(PreviewPanel1.SourceBitmap,ResultBitmap,
      RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
      PreviewPanel1.SourceBitmap.Assign(ResultBitmap);
   end
    else if PageControl1.ActivePage=GammaSheet then
    begin
       EffectGamma(PreviewPanel1.SourceBitmap,ResultBitmap,Gamma,nil);
       PreviewPanel1.SourceBitmap.Assign(ResultBitmap);
    end
    else if PageControl1.ActivePage= ContrastSheet then
    begin
      tb:=TBitmap.Create;
      try
        EffectContrast(PreviewPanel1.SourceBitmap,ResultBitmap,
        ExtTrackBar5.Position,true,true,true,nil);
        tb.Assign(ResultBitmap);
        EffectLightness(tb,ResultBitmap,
        ExtTrackBar4.Position,true,true,true,nil);
      finally
        tb.free;
      end;
      PreviewPanel1.SourceBitmap.Assign(ResultBitmap);
    end;

  finally
  Screen.Cursor:=crDefault;
  end;

end;

procedure TColCtrlForm.Button1Click(Sender: TObject);
begin
  EffectColorize(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,
  ExtTrackBar1.Position,ExtTrackBar2.Position,ExtTrackBar3.Position,nil);
  PreviewPanel1.PreviewImage.Repaint;
end;

procedure TColCtrlForm.RGBClick;
var tb:TBitmap;
begin
  if SwapMode<>swapNone then
  begin
    tb:=TBitmap.Create;
    try
      EffectSwapChannels(PreviewPanel1.OriginalImage.Picture.Bitmap,tb,SwapMode,nil);
      EffectIncDecRGB(tb,PreviewPanel1.PreviewImage.Picture.Bitmap,
      RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
    finally
      tb.Free;
    end;
  end else
  EffectIncDecRGB(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,
  RedTrack.Position,GreenTrack.Position,BlueTrack.Position,nil);
  PreviewPanel1.PreviewImage.Repaint;
end;

procedure TColCtrlForm.FormDestroy(Sender: TObject);
begin
  DecimalSeparator:=',';
  ResultBitmap.Free;
end;

procedure TColCtrlForm.PreviewPanel1OrgPosChanged(Sender: TObject);
begin
  if PageControl1.ActivePage=HSLSheet then
  Button1Click(self)
  else if PageControl1.ActivePage=RGBSheet then RGBClick
  else if PageControl1.ActivePage=GammaSheet
  then GammaTrackChange(self);
end;





procedure TColCtrlForm.SpinEdit1Change(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text='' then (Sender as TSpinEdit).Text:='0';
  ExtTrackbar1.Position:=Spinedit1.Value;
  ExtTrackbar2.Position:=Spinedit2.Value;
  ExtTrackbar3.Position:=Spinedit3.Value;
  Button1Click(self);
end;

procedure TColCtrlForm.ExtTrackBar1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

 if (Sender as TExtTrackBar).Position<>(Sender as TExtTrackBar).Tag then
  begin
   (Sender as TExtTrackBar).Tag:=(Sender as TExtTrackBar).Position;
   Button1Click(self);
  end;
end;

procedure TColCtrlForm.ExtTrackBar1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   (Sender as TExtTrackBar).Tag:=(Sender as TExtTrackBar).Position;
end;

procedure TColCtrlForm.ExtTrackBar1Change(Sender: TObject);
begin
   SpinEdit1.Value:=ExtTrackBar1.Position;
   SpinEdit2.Value:=ExtTrackBar2.Position;
   SpinEdit3.Value:=ExtTrackBar3.Position;
end;


procedure TColCtrlForm.RedTrackMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   (Sender as TExtTrackBar).Tag:=(Sender as TExtTrackBar).Position;
end;

procedure TColCtrlForm.RedTrackMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if (Sender as TExtTrackBar).Position<>(Sender as TExtTrackBar).Tag then
  begin
   (Sender as TExtTrackBar).Tag:=(Sender as TExtTrackBar).Position;
   RGBClick;
  end;
end;

procedure TColCtrlForm.RedTrackChange(Sender: TObject);
begin
   RedSpin.Value:=RedTrack.Position;
   GreenSpin.Value:=GreenTrack.Position;
   BlueSpin.Value:=BlueTrack.Position;
end;

procedure TColCtrlForm.RedSpinChange(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text='' then (Sender as TSpinEdit).Text:='0';
  RedTrack.Position:=RedSpin.Value;
  GreenTrack.Position:=GreenSpin.Value;
  BlueTrack.Position:=BlueSpin.Value;
  RGBClick;
end;

procedure TColCtrlForm.SwapPlanesClick(Sender: TObject);
begin
 {  case RadioGroup1.Itemindex of
  0:SwapMode:=swapNone;
  1:SwapMode:=swapRedGreen;
  2:SwapMode:=swapRedBlue;
  3:SwapMode:=swapBlueGreen;
  end;

  RedTrackChange(Self);
  RGBClick;}
end;

procedure TColCtrlForm.GammaTrackChange(Sender: TObject);
var x:Extended;
    i,k:Integer;
begin
  x:=GammaTrack.Position /100 ;
  Edit1.Text:= FloatToStr(x);
  Gamma := x;
  EffectGamma(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,
  x,nil);
  PreviewPanel1.PreviewImage.Repaint;
  Image1.Picture.Bitmap.Width:=Image1.Width;
  Image1.Picture.Bitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.Canvas.MoveTo(0,Image1.Height-1);
  Image1.Picture.Bitmap.Canvas.Brush.Color:=clWhite;
  Image1.Picture.Bitmap.Canvas.FillRect(Image1.ClientRect);
  for i:=1 to 255 do
  begin
    k:=IntGamma(Gamma,i);
    Image1.Picture.Bitmap.Canvas.LineTo(i div 2,Image1.Height-( k div 2)-1);
  end;
  Image1.Repaint;
end;

procedure TColCtrlForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key =#13 then
  begin
    GammaTrack.Position:=Round(StrToFloat(Edit1.Text) * 100);
    GammaTrackChange(self);
  end;
end;

procedure TColCtrlForm.ExtTrackBar5Change(Sender: TObject);
begin
  SpinEdit4.Value:=ExtTrackBar4.Position;
  SpinEdit5.Value:=ExtTrackBar5.Position;
end;

procedure TColCtrlForm.ExtTrackBar5MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

 if (Sender as TExtTrackBar).Position<>(Sender as TExtTrackBar).Tag then
  begin
   (Sender as TExtTrackBar).Tag:=(Sender as TExtTrackBar).Position;
   LigCont;
  end;

end;

procedure TColCtrlForm.SpinEdit4Change(Sender: TObject);
begin
  if (Sender as TSpinEdit).Text='' then (Sender as TSpinEdit).Text:='0';
  ExtTrackbar4.Position:=Spinedit4.Value;
  ExtTrackbar5.Position:=Spinedit5.Value;
  LigCont;
end;

procedure TColCtrlForm.LigCont;
var TempBitmap:TBitmap;
begin
 TempBitmap:=TBitmap.Create;
 try

  EffectContrast(PreviewPanel1.OriginalImage.Picture.Bitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,
  ExtTrackBar5.Position,true,true,true,nil);
  TempBitmap.Assign(PreviewPanel1.PreviewImage.Picture.Bitmap);
  EffectLightness(TempBitmap,PreviewPanel1.PreviewImage.Picture.Bitmap,
  ExtTrackBar4.Position,true,true,true,nil);
  PreviewPanel1.PreviewImage.Repaint;

 finally
   TempBitmap.Free;
 end;
end;

end.

